#include "Forthon.h"
#include <setjmp.h>
ForthonObject *fKDObject;
extern jmp_buf stackenvironment;
extern int lstackenvironmentset;
extern void fkdpasspointers_(void);
extern void fkdnullifypointers_(void);
extern void find_nn_nearest_neighbors_(void);
extern void create_tree_(long *treeID);
extern void add_tree_(long *treeID);
extern void free_tree_(long *treeID);
extern void find_all_nn_nearest_neighbors_(void);
extern void find_r_nearest_(void);
extern void find_many_r_nearest_(long *treeID);
extern void find_many_nn_nearest_neighbors_(void);
extern void find_chunk_nearest_neighbors_(void);
extern void chainhop_tags_dens_(void);
extern PyObject *fKD_intervalNew(PyObject *self, PyObject *args);
extern PyObject *fKD_tree_nodeNew(PyObject *self, PyObject *args);
extern PyObject *fKD_kdtree2New(PyObject *self, PyObject *args);
extern PyObject *fKD_tree_setNew(PyObject *self, PyObject *args);

extern void fkdsetpointert1_(char *p,long *cobj__);
extern void fkdgetpointert1_(ForthonObject **cobj__,long *obj,int *createnew);
extern void fkdsetpointert2_(char *p,long *cobj__);
extern void fkdgetpointert2_(ForthonObject **cobj__,long *obj,int *createnew);
extern void fkdsetpointertree2_(char *p,long *cobj__);
extern void fkdgetpointertree2_(ForthonObject **cobj__,long *obj,int *createnew);
extern void fkdsetpointertags_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointertags_(long *i,long *cobj__);
extern void fkdsetpointerdist_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointerdist_(long *i,long *cobj__);
extern void fkdsetpointernn_tags_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointernn_tags_(long *i,long *cobj__);
extern void fkdsetpointerchunk_tags_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointerchunk_tags_(long *i,long *cobj__);
extern void fkdsetpointernn_dist_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointernn_dist_(long *i,long *cobj__);
extern void fkdsetpointerpos_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointerpos_(long *i,long *cobj__);
extern void fkdsetpointerdens_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointerdens_(long *i,long *cobj__);
extern void fkdsetpointermass_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointermass_(long *i,long *cobj__);
extern void fkdsetpointerqv_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdsetpointerqv_many_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointerqv_many_(long *i,long *cobj__);
extern void fkdsetpointernfound_many_(char *p,long *cobj__,npy_intp *dims__);
extern void fkdgetpointernfound_many_(long *i,long *cobj__);

int fKDnscalars = 13;
Fortranscalar fKD_fscalars[13]={
{PyArray_OBJECT,"tree_set","t1",NULL,"fKD_module"," fKD_module vars ","",1,NULL,NULL,NULL,NULL},
{PyArray_OBJECT,"tree_set","t2",NULL,"fKD_module"," fKD_module vars ","This contains the objects that any given kD tree might wish to use.\nNot all of these are being used all the time, but they only take memory\nif they're initialized in python.",1,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","nparts",NULL,"fKD_module"," fKD_module vars ","",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","nn",NULL,"fKD_module"," fKD_module vars ","",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","nMerge",NULL,"fKD_module"," fKD_module vars ","number of nearest neighbors used in chain merging",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","start",NULL,"fKD_module"," fKD_module vars ","",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","finish",NULL,"fKD_module"," fKD_module vars ","",0,NULL,NULL,NULL,NULL},
{PyArray_OBJECT,"kdtree2","tree2",NULL,"fKD_module"," fKD_module vars ","",1,NULL,NULL,NULL,NULL},
{PyArray_LONG,"logical","sort",NULL,"fKD_module"," fKD_module vars ","",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"logical","rearrange",NULL,"fKD_module"," fKD_module vars ","",0,NULL,NULL,NULL,NULL},
{PyArray_DOUBLE,"real","radius",NULL,"fKD_module"," fKD_module vars ","the unsquared radius for radius searches",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","radius_n",NULL,"fKD_module"," fKD_module vars ","the number of results to return",0,NULL,NULL,NULL,NULL},
{PyArray_LONG,"integer","nfound",NULL,"fKD_module"," fKD_module vars ","number of neighbors within radius",0,NULL,NULL,NULL,NULL}};
int fKDnarrays = 11;
static Fortranarray fKD_farrays[11]={
{PyArray_LONG,3,1,NULL,"tags",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","particle ID tags","(:)"},
{PyArray_DOUBLE,3,1,NULL,"dist",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","interparticle spacings","(:)"},
{PyArray_LONG,3,2,NULL,"nn_tags",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign  fassign ","for all particles at once, [nth neighbor, index]","(:,:)"},
{PyArray_LONG,3,2,NULL,"chunk_tags",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign  fassign ","for finding only a chunk of the nearest neighbors","(:,:)"},
{PyArray_DOUBLE,3,2,NULL,"nn_dist",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign  fassign ","","(:,:)"},
{PyArray_DOUBLE,3,2,NULL,"pos",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","","(3,:)"},
{PyArray_DOUBLE,3,1,NULL,"dens",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","","(:)"},
{PyArray_DOUBLE,3,1,NULL,"mass",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","","(:)"},
{PyArray_DOUBLE,0,1,NULL,"qv",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars ","","(3)"},
{PyArray_DOUBLE,3,2,NULL,"qv_many",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","","(3,:)"},
{PyArray_LONG,3,1,NULL,"nfound_many",{NULL},NULL,NULL,NULL,NULL,0,NULL,"fKD_module"," fKD_module vars  fassign ","an array of number of neighbors within radius","(:)"}};
void fKDdeclarevars(ForthonObject *obj) {
obj->fscalars[0].setpointer = *fkdsetpointert1_;
obj->fscalars[0].getpointer = *fkdgetpointert1_;
obj->fscalars[1].setpointer = *fkdsetpointert2_;
obj->fscalars[1].getpointer = *fkdgetpointert2_;
obj->fscalars[7].setpointer = *fkdsetpointertree2_;
obj->fscalars[7].getpointer = *fkdgetpointertree2_;
obj->farrays[0].setpointer = *fkdsetpointertags_;
obj->farrays[0].getpointer = *fkdgetpointertags_;
obj->farrays[1].setpointer = *fkdsetpointerdist_;
obj->farrays[1].getpointer = *fkdgetpointerdist_;
obj->farrays[2].setpointer = *fkdsetpointernn_tags_;
obj->farrays[2].getpointer = *fkdgetpointernn_tags_;
obj->farrays[3].setpointer = *fkdsetpointerchunk_tags_;
obj->farrays[3].getpointer = *fkdgetpointerchunk_tags_;
obj->farrays[4].setpointer = *fkdsetpointernn_dist_;
obj->farrays[4].getpointer = *fkdgetpointernn_dist_;
obj->farrays[5].setpointer = *fkdsetpointerpos_;
obj->farrays[5].getpointer = *fkdgetpointerpos_;
obj->farrays[6].setpointer = *fkdsetpointerdens_;
obj->farrays[6].getpointer = *fkdgetpointerdens_;
obj->farrays[7].setpointer = *fkdsetpointermass_;
obj->farrays[7].getpointer = *fkdgetpointermass_;
obj->farrays[9].setpointer = *fkdsetpointerqv_many_;
obj->farrays[9].getpointer = *fkdgetpointerqv_many_;
obj->farrays[10].setpointer = *fkdsetpointernfound_many_;
obj->farrays[10].getpointer = *fkdgetpointernfound_many_;
}
static char doc_fKD_find_nn_nearest_neighbors[] = "find_nn_nearest_neighbors\n";
static PyObject *
fKD_find_nn_nearest_neighbors(PyObject *self, PyObject *args)
{
  if (!PyArg_ParseTuple(args, "")) return NULL;
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
find_nn_nearest_neighbors_();
  lstackenvironmentset--;
  returnnone;
err:
  return NULL;
}
static char doc_fKD_create_tree[] = "create_tree(treeID:integer)\n";
static PyObject *
fKD_create_tree(PyObject *self, PyObject *args)
{
  PyObject * pyobj[1];
  PyArrayObject * ax[1];
  int i;
  char e[256];
  for (i=0;i<1;i++) ax[i] = NULL;
  if (!PyArg_ParseTuple(args, "O",&pyobj[0])) return NULL;
  if (!Forthon_checksubroutineargtype(pyobj[0],PyArray_LONG)) {
    sprintf(e,"Argument 1 in create_tree has the wrong type");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  ax[0] = FARRAY_FROMOBJECT(pyobj[0], PyArray_LONG);
  if (ax[0] == NULL) {
    sprintf(e,"There is an error in argument 1 in create_tree");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
create_tree_((long *)(PyArray_BYTES(ax[0])));
  lstackenvironmentset--;
  Forthon_restoresubroutineargs(1,pyobj,ax);
  returnnone;
err:
  for (i=0;i<1;i++)
    if (ax[i] != NULL) {Py_XDECREF(ax[i]);}
  return NULL;
}
static char doc_fKD_add_tree[] = "add_tree(treeID:integer)\n";
static PyObject *
fKD_add_tree(PyObject *self, PyObject *args)
{
  PyObject * pyobj[1];
  PyArrayObject * ax[1];
  int i;
  char e[256];
  for (i=0;i<1;i++) ax[i] = NULL;
  if (!PyArg_ParseTuple(args, "O",&pyobj[0])) return NULL;
  if (!Forthon_checksubroutineargtype(pyobj[0],PyArray_LONG)) {
    sprintf(e,"Argument 1 in add_tree has the wrong type");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  ax[0] = FARRAY_FROMOBJECT(pyobj[0], PyArray_LONG);
  if (ax[0] == NULL) {
    sprintf(e,"There is an error in argument 1 in add_tree");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
add_tree_((long *)(PyArray_BYTES(ax[0])));
  lstackenvironmentset--;
  Forthon_restoresubroutineargs(1,pyobj,ax);
  returnnone;
err:
  for (i=0;i<1;i++)
    if (ax[i] != NULL) {Py_XDECREF(ax[i]);}
  return NULL;
}
static char doc_fKD_free_tree[] = "free_tree(treeID:integer)\n";
static PyObject *
fKD_free_tree(PyObject *self, PyObject *args)
{
  PyObject * pyobj[1];
  PyArrayObject * ax[1];
  int i;
  char e[256];
  for (i=0;i<1;i++) ax[i] = NULL;
  if (!PyArg_ParseTuple(args, "O",&pyobj[0])) return NULL;
  if (!Forthon_checksubroutineargtype(pyobj[0],PyArray_LONG)) {
    sprintf(e,"Argument 1 in free_tree has the wrong type");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  ax[0] = FARRAY_FROMOBJECT(pyobj[0], PyArray_LONG);
  if (ax[0] == NULL) {
    sprintf(e,"There is an error in argument 1 in free_tree");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
free_tree_((long *)(PyArray_BYTES(ax[0])));
  lstackenvironmentset--;
  Forthon_restoresubroutineargs(1,pyobj,ax);
  returnnone;
err:
  for (i=0;i<1;i++)
    if (ax[i] != NULL) {Py_XDECREF(ax[i]);}
  return NULL;
}
static char doc_fKD_find_all_nn_nearest_neighbors[] = "find_all_nn_nearest_neighbors\n";
static PyObject *
fKD_find_all_nn_nearest_neighbors(PyObject *self, PyObject *args)
{
  if (!PyArg_ParseTuple(args, "")) return NULL;
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
find_all_nn_nearest_neighbors_();
  lstackenvironmentset--;
  returnnone;
err:
  return NULL;
}
static char doc_fKD_find_r_nearest[] = "find_r_nearest\n";
static PyObject *
fKD_find_r_nearest(PyObject *self, PyObject *args)
{
  if (!PyArg_ParseTuple(args, "")) return NULL;
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
find_r_nearest_();
  lstackenvironmentset--;
  returnnone;
err:
  return NULL;
}
static char doc_fKD_find_many_r_nearest[] = "find_many_r_nearest(treeID:integer)\n";
static PyObject *
fKD_find_many_r_nearest(PyObject *self, PyObject *args)
{
  PyObject * pyobj[1];
  PyArrayObject * ax[1];
  int i;
  char e[256];
  for (i=0;i<1;i++) ax[i] = NULL;
  if (!PyArg_ParseTuple(args, "O",&pyobj[0])) return NULL;
  if (!Forthon_checksubroutineargtype(pyobj[0],PyArray_LONG)) {
    sprintf(e,"Argument 1 in find_many_r_nearest has the wrong type");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  ax[0] = FARRAY_FROMOBJECT(pyobj[0], PyArray_LONG);
  if (ax[0] == NULL) {
    sprintf(e,"There is an error in argument 1 in find_many_r_nearest");
    PyErr_SetString(ErrorObject,e);
    goto err;}
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
find_many_r_nearest_((long *)(PyArray_BYTES(ax[0])));
  lstackenvironmentset--;
  Forthon_restoresubroutineargs(1,pyobj,ax);
  returnnone;
err:
  for (i=0;i<1;i++)
    if (ax[i] != NULL) {Py_XDECREF(ax[i]);}
  return NULL;
}
static char doc_fKD_find_many_nn_nearest_neighbors[] = "find_many_nn_nearest_neighbors\n";
static PyObject *
fKD_find_many_nn_nearest_neighbors(PyObject *self, PyObject *args)
{
  if (!PyArg_ParseTuple(args, "")) return NULL;
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
find_many_nn_nearest_neighbors_();
  lstackenvironmentset--;
  returnnone;
err:
  return NULL;
}
static char doc_fKD_find_chunk_nearest_neighbors[] = "find_chunk_nearest_neighbors\n";
static PyObject *
fKD_find_chunk_nearest_neighbors(PyObject *self, PyObject *args)
{
  if (!PyArg_ParseTuple(args, "")) return NULL;
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
find_chunk_nearest_neighbors_();
  lstackenvironmentset--;
  returnnone;
err:
  return NULL;
}
static char doc_fKD_chainHOP_tags_dens[] = "chainHOP_tags_dens\n";
static PyObject *
fKD_chainHOP_tags_dens(PyObject *self, PyObject *args)
{
  if (!PyArg_ParseTuple(args, "")) return NULL;
  if (!(lstackenvironmentset++) && setjmp(stackenvironment)) goto err;
  
chainhop_tags_dens_();
  lstackenvironmentset--;
  returnnone;
err:
  return NULL;
}

static struct PyMethodDef fKD_methods[] = {
{"find_nn_nearest_neighbors",(PyCFunction)fKD_find_nn_nearest_neighbors,1,doc_fKD_find_nn_nearest_neighbors},
{"create_tree",(PyCFunction)fKD_create_tree,1,doc_fKD_create_tree},
{"add_tree",(PyCFunction)fKD_add_tree,1,doc_fKD_add_tree},
{"free_tree",(PyCFunction)fKD_free_tree,1,doc_fKD_free_tree},
{"find_all_nn_nearest_neighbors",(PyCFunction)fKD_find_all_nn_nearest_neighbors,1,doc_fKD_find_all_nn_nearest_neighbors},
{"find_r_nearest",(PyCFunction)fKD_find_r_nearest,1,doc_fKD_find_r_nearest},
{"find_many_r_nearest",(PyCFunction)fKD_find_many_r_nearest,1,doc_fKD_find_many_r_nearest},
{"find_many_nn_nearest_neighbors",(PyCFunction)fKD_find_many_nn_nearest_neighbors,1,doc_fKD_find_many_nn_nearest_neighbors},
{"find_chunk_nearest_neighbors",(PyCFunction)fKD_find_chunk_nearest_neighbors,1,doc_fKD_find_chunk_nearest_neighbors},
{"chainHOP_tags_dens",(PyCFunction)fKD_chainHOP_tags_dens,1,doc_fKD_chainHOP_tags_dens},
{"interval",(PyCFunction)fKD_intervalNew,1,"Creates a new instance of fortran derived type interval"},
{"tree_node",(PyCFunction)fKD_tree_nodeNew,1,"Creates a new instance of fortran derived type tree_node"},
{"kdtree2",(PyCFunction)fKD_kdtree2New,1,"Creates a new instance of fortran derived type kdtree2"},
{"tree_set",(PyCFunction)fKD_tree_setNew,1,"Creates a new instance of fortran derived type tree_set"},
{NULL,NULL}};

void fKDsetstaticdims(ForthonObject *self)
{
  fKD_farrays[8].dimensions[0] = (npy_intp)((3) - (1) + 1);
}

static void fKDsetdimsfKD_module(char *name,long i)
{
  if (strcmp(name,"fKD_module") || strcmp(name,"*")) {
  }}
void fKDsetdims(char *name,ForthonObject *obj,long i)
{
  if (i == -1 || (0 <= i && i <= 11))  fKDsetdimsfKD_module(name,i);
}

void fkdsetscalarpointers_(long *i,char *p)
{
  /* Get pointers for the scalars */
  fKD_fscalars[*i].data = (char *)p;
}
void fkdsetderivedtypepointers_(long *i,char **p)
{
  /* Get pointers for the scalars */
  fKD_fscalars[*i].data = (char *)(*p);
}
void fkdsetarraypointers_(long *i,char *p)
{
  /* Get pointers for the arrays */
  fKD_farrays[*i].data.s = (char *)p;
}
void fkdsetarraypointersobj_(Fortranarray *farray,char *p)
{
  /* Get pointers for the arrays */
  farray->data.s = (char *)p;
}
void fkdsetarraydims_(Fortranarray *farray,long *dims)
{
  int id;
  for (id=0;id<farray->nd;id++)
    farray->dimensions[farray->nd-1-id] = (npy_intp)(dims[id]);
}
PyMODINIT_FUNC
initfKDpy(void)
{
  PyObject *m;
  if (PyType_Ready(&ForthonType) < 0)
    return;
  m = Py_InitModule("fKDpy",fKD_methods);
  fKDObject=(ForthonObject *)PyObject_GC_New(ForthonObject, &ForthonType);
  fKDObject->name = "fKD";
  fKDObject->typename = "fKD";
  fKDObject->nscalars = fKDnscalars;
  fKDObject->fscalars = fKD_fscalars;
  fKDObject->narrays = fKDnarrays;
  fKDObject->farrays = fKD_farrays;
  fKDObject->setdims = *fKDsetdims;
  fKDObject->setstaticdims = *fKDsetstaticdims;
  fKDObject->fmethods = fKD_methods;
  fKDObject->__module__ = Py_BuildValue("s","fKDpy");
  fKDObject->fobj = NULL;
  fKDObject->fobjdeallocate = NULL;
  fKDObject->nullifycobj = NULL;
  fKDObject->allocated = 0;
  fKDObject->garbagecollected = 0;
  PyModule_AddObject(m,"fKD",(PyObject *)fKDObject);
  ErrorObject = PyUnicode_FromString("fKDpy.error");
  PyModule_AddObject(m,"fKDerror", ErrorObject);
  PyModule_AddObject(m,"fcompname",PyUnicode_FromString("gfortran"));
  PyModule_AddObject(m,"realsize",PyLong_FromLong((long)8));
  if (PyErr_Occurred()) {
    PyErr_Print();
    Py_FatalError("can not initialize module fKD");
    }
  import_array();
  fKDdeclarevars(fKDObject);
  Forthon_BuildDicts(fKDObject);
  ForthonPackage_allotdims(fKDObject);
  fkdpasspointers_();
  fkdnullifypointers_();
  ForthonPackage_staticarrays(fKDObject);
  {
  PyObject *m, *d, *f, *r;
  r = NULL;
  m = PyImport_ImportModule("Forthon");
  if (m != NULL) {
    d = PyModule_GetDict(m);
    if (d != NULL) {
      f = PyDict_GetItemString(d,"registerpackage");
      if (f != NULL) {
        r = PyObject_CallFunction(f,"Os",(PyObject *)fKDObject,"fKD");
  }}}
  if (NULL == r) {
    if (PyErr_Occurred()) PyErr_Print();
    Py_FatalError("unable to find a compatible Forthon module in which to register module fKD");
  }
  Py_XDECREF(m);
  Py_XDECREF(r);
  }
}


static char* intervalpointee__ = "interval";
extern void intervalpasspointers_(char *fobj,long *setinitvalues);
extern void intervalnullifypointers_(char *fobj);
extern PyObject *intervalnewf_(void);
extern void intervaldeallocatef_(void);
extern void intervalnullifycobjf_(void);
extern void intervalsetpointerlower_(char *p,char *fobj,int *nullit);
extern void intervalsetpointerupper_(char *p,char *fobj,int *nullit);


void intervaldeclarevars(ForthonObject *obj) {
obj->nscalars = 2;
obj->fscalars = PyMem_Malloc(obj->nscalars*sizeof(Fortranscalar));
obj->fscalars[0].type = PyArray_DOUBLE;
obj->fscalars[0].typename = "real";
obj->fscalars[0].name = "lower";
obj->fscalars[0].data = NULL;
obj->fscalars[0].group = "interval";
obj->fscalars[0].attributes = " interval ";
obj->fscalars[0].comment = "";
obj->fscalars[0].dynamic = 0;
obj->fscalars[0].setpointer = *intervalsetpointerlower_;
obj->fscalars[0].getpointer = NULL;
obj->fscalars[0].setaction = NULL;
obj->fscalars[0].getaction = NULL;
obj->fscalars[1].type = PyArray_DOUBLE;
obj->fscalars[1].typename = "real";
obj->fscalars[1].name = "upper";
obj->fscalars[1].data = NULL;
obj->fscalars[1].group = "interval";
obj->fscalars[1].attributes = " interval ";
obj->fscalars[1].comment = "real(kdkind) :: lower,upper";
obj->fscalars[1].dynamic = 0;
obj->fscalars[1].setpointer = *intervalsetpointerupper_;
obj->fscalars[1].getpointer = NULL;
obj->fscalars[1].setaction = NULL;
obj->fscalars[1].getaction = NULL;
obj->narrays = 0;
obj->farrays = NULL;
}
void intervalsetstaticdims(ForthonObject *obj)
{
}
static void intervalsetdims(char *name,ForthonObject *obj,long i)
{
}
PyObject *fKD_intervalNew(PyObject *self, PyObject *args)
{
  return intervalnewf_();
}
static struct PyMethodDef interval_methods[]={{NULL,NULL}};
void initintervalpy_(long *i,char *fobj,ForthonObject **cobj__,long *setinitvalues,long *deallocatable)
{
  ForthonObject *obj;
  obj=(ForthonObject *) PyObject_GC_New(ForthonObject,&ForthonType);
  if (*i > 0) {obj->name = fKD_fscalars[*i].name;}
  else        {obj->name = intervalpointee__;}
  obj->typename = "interval";
  intervaldeclarevars(obj);
  obj->setdims = *intervalsetdims;
  obj->setstaticdims = *intervalsetstaticdims;
  obj->fmethods = interval_methods;
  obj->__module__ = Py_BuildValue("s","fKDpy");
  obj->fobj = fobj;
  if (*deallocatable==1)
    obj->fobjdeallocate=*intervaldeallocatef_;
  else
    obj->fobjdeallocate = NULL;
  obj->nullifycobj=*intervalnullifycobjf_;
  obj->allocated = 0;
  obj->garbagecollected = 0;
  *cobj__ = obj;
  if (PyErr_Occurred()) {
    PyErr_Print();
    Py_FatalError("can not initialize type interval");
    }
  Forthon_BuildDicts(obj);
  ForthonPackage_allotdims(obj);
  intervalpasspointers_(fobj,setinitvalues);
  intervalnullifypointers_(fobj);
  ForthonPackage_staticarrays(obj);
}
void increfintervalpy_(ForthonObject **cobj__,char *fobj)
{
  if (*cobj__ == NULL) {
    long i=-1,s=0,d=0;
    initintervalpy_(&i,fobj,cobj__,&s,&d);}
  else {
    Py_INCREF(*cobj__);}
}
void decrefintervalpy_(ForthonObject **cobj__)
{
  Py_XDECREF(*cobj__);
}
void intervalmakedeallocable_(ForthonObject **cobj)
{
  (*cobj)->fobjdeallocate=*intervaldeallocatef_;
}
void intervalsetscalarpointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the scalars */
  (*obj)->fscalars[*i].data = (char *)p;
}
void intervalsetderivedtypepointers_(long *i,char **p,ForthonObject **obj)
{
  /* Get pointers for the derived types */
  (*obj)->fscalars[*i].data = (char *)(*p);
}
void intervalsetarraypointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the arrays */
  (*obj)->farrays[*i].data.s = (char *)p;
}
void intervalsetarraypointersobj_(Fortranarray *farray,char *p)
{
  /* Get pointers for the arrays */
  farray->data.s = (char *)p;
}
void intervalsetarraydims_(Fortranarray *farray,long *dims)
{
  int id;
  for (id=0;id<farray->nd;id++)
    farray->dimensions[farray->nd-1-id] = (npy_intp)(dims[id]);
}

static char* tree_nodepointee__ = "tree_node";
extern void tree_nodepasspointers_(char *fobj,long *setinitvalues);
extern void tree_nodenullifypointers_(char *fobj);
extern PyObject *tree_nodenewf_(void);
extern void tree_nodedeallocatef_(void);
extern void tree_nodenullifycobjf_(void);
extern void tree_nodesetpointercut_dim_(char *p,char *fobj,int *nullit);
extern void tree_nodesetpointercut_val_(char *p,char *fobj,int *nullit);
extern void tree_nodesetpointercut_val_left_(char *p,char *fobj,int *nullit);
extern void tree_nodesetpoiypbmdunhvsvchoal_(char *p,char *fobj,int *nullit);
extern void tree_nodesetpointeru_(char *p,char *fobj,int *nullit);
extern void tree_nodesetpointerl_(char *p,char *fobj,int *nullit);
extern void tree_nodesetpointerleft_(char *p,char *fobj,int *nullit);
extern void tree_nodegetpointerleft_(ForthonObject **cobj__,char *obj,int *createnew__);
extern void tree_nodesetpointerright_(char *p,char *fobj,int *nullit);
extern void tree_nodegetpointerright_(ForthonObject **cobj__,char *obj,int *createnew__);
extern void tree_nodesetpointerbox_(char *p,char *fobj,npy_intp *dims__);
extern void tree_nodegetpointerbox_(long *i,char* fobj);


void tree_nodedeclarevars(ForthonObject *obj) {
obj->nscalars = 8;
obj->fscalars = PyMem_Malloc(obj->nscalars*sizeof(Fortranscalar));
obj->fscalars[0].type = PyArray_LONG;
obj->fscalars[0].typename = "integer";
obj->fscalars[0].name = "cut_dim";
obj->fscalars[0].data = NULL;
obj->fscalars[0].group = "tree_node";
obj->fscalars[0].attributes = " tree_node ";
obj->fscalars[0].comment = "integer :: cut_dim\nthe dimension to cut";
obj->fscalars[0].dynamic = 0;
obj->fscalars[0].setpointer = *tree_nodesetpointercut_dim_;
obj->fscalars[0].getpointer = NULL;
obj->fscalars[0].setaction = NULL;
obj->fscalars[0].getaction = NULL;
obj->fscalars[1].type = PyArray_DOUBLE;
obj->fscalars[1].typename = "real";
obj->fscalars[1].name = "cut_val";
obj->fscalars[1].data = NULL;
obj->fscalars[1].group = "tree_node";
obj->fscalars[1].attributes = " tree_node ";
obj->fscalars[1].comment = "real(kdkind) :: cut_val\nwhere to cut the dimension";
obj->fscalars[1].dynamic = 0;
obj->fscalars[1].setpointer = *tree_nodesetpointercut_val_;
obj->fscalars[1].getpointer = NULL;
obj->fscalars[1].setaction = NULL;
obj->fscalars[1].getaction = NULL;
obj->fscalars[2].type = PyArray_DOUBLE;
obj->fscalars[2].typename = "real";
obj->fscalars[2].name = "cut_val_left";
obj->fscalars[2].data = NULL;
obj->fscalars[2].group = "tree_node";
obj->fscalars[2].attributes = " tree_node ";
obj->fscalars[2].comment = "";
obj->fscalars[2].dynamic = 0;
obj->fscalars[2].setpointer = *tree_nodesetpointercut_val_left_;
obj->fscalars[2].getpointer = NULL;
obj->fscalars[2].setaction = NULL;
obj->fscalars[2].getaction = NULL;
obj->fscalars[3].type = PyArray_DOUBLE;
obj->fscalars[3].typename = "real";
obj->fscalars[3].name = "cut_val_right";
obj->fscalars[3].data = NULL;
obj->fscalars[3].group = "tree_node";
obj->fscalars[3].attributes = " tree_node ";
obj->fscalars[3].comment = "real(kdkind) :: cut_val_left, cut_val_right \nimproved cutoffs knowing the spread in child boxes.";
obj->fscalars[3].dynamic = 0;
obj->fscalars[3].setpointer = *tree_nodesetpoiypbmdunhvsvchoal_;
obj->fscalars[3].getpointer = NULL;
obj->fscalars[3].setaction = NULL;
obj->fscalars[3].getaction = NULL;
obj->fscalars[4].type = PyArray_LONG;
obj->fscalars[4].typename = "integer";
obj->fscalars[4].name = "u";
obj->fscalars[4].data = NULL;
obj->fscalars[4].group = "tree_node";
obj->fscalars[4].attributes = " tree_node ";
obj->fscalars[4].comment = "";
obj->fscalars[4].dynamic = 0;
obj->fscalars[4].setpointer = *tree_nodesetpointeru_;
obj->fscalars[4].getpointer = NULL;
obj->fscalars[4].setaction = NULL;
obj->fscalars[4].getaction = NULL;
obj->fscalars[5].type = PyArray_LONG;
obj->fscalars[5].typename = "integer";
obj->fscalars[5].name = "l";
obj->fscalars[5].data = NULL;
obj->fscalars[5].group = "tree_node";
obj->fscalars[5].attributes = " tree_node ";
obj->fscalars[5].comment = "integer :: l, u";
obj->fscalars[5].dynamic = 0;
obj->fscalars[5].setpointer = *tree_nodesetpointerl_;
obj->fscalars[5].getpointer = NULL;
obj->fscalars[5].setaction = NULL;
obj->fscalars[5].getaction = NULL;
obj->fscalars[6].type = PyArray_OBJECT;
obj->fscalars[6].typename = "tree_node";
obj->fscalars[6].name = "left";
obj->fscalars[6].data = NULL;
obj->fscalars[6].group = "tree_node";
obj->fscalars[6].attributes = " tree_node ";
obj->fscalars[6].comment = "";
obj->fscalars[6].dynamic = 1;
obj->fscalars[6].setpointer = *tree_nodesetpointerleft_;
obj->fscalars[6].getpointer = *tree_nodegetpointerleft_;
obj->fscalars[6].setaction = NULL;
obj->fscalars[6].getaction = NULL;
obj->fscalars[7].type = PyArray_OBJECT;
obj->fscalars[7].typename = "tree_node";
obj->fscalars[7].name = "right";
obj->fscalars[7].data = NULL;
obj->fscalars[7].group = "tree_node";
obj->fscalars[7].attributes = " tree_node ";
obj->fscalars[7].comment = "type(tree_node), pointer :: left, right";
obj->fscalars[7].dynamic = 1;
obj->fscalars[7].setpointer = *tree_nodesetpointerright_;
obj->fscalars[7].getpointer = *tree_nodegetpointerright_;
obj->fscalars[7].setaction = NULL;
obj->fscalars[7].getaction = NULL;
obj->narrays = 1;
obj->farrays = PyMem_Malloc(obj->narrays*sizeof(Fortranarray));
obj->farrays[0].type = PyArray_OBJECT;
obj->farrays[0].dynamic = 3;
obj->farrays[0].nd = 1;
obj->farrays[0].dimensions = (npy_intp*)NULL;
obj->farrays[0].name = "box";
obj->farrays[0].data.s = (char *)NULL;
obj->farrays[0].setpointer = *tree_nodesetpointerbox_;
obj->farrays[0].getpointer = *tree_nodegetpointerbox_;
obj->farrays[0].setaction = NULL;
obj->farrays[0].getaction = NULL;
obj->farrays[0].initvalue = 0;
obj->farrays[0].pya = NULL;
obj->farrays[0].group = "tree_node";
obj->farrays[0].attributes = " tree_node  fassign ";
obj->farrays[0].comment = "type(interval), pointer :: box(:) => null()\nchild pointers\nPoints included in this node are indexes[k] with k in [l,u]";
obj->farrays[0].dimstring = "(:)";
}
void tree_nodesetstaticdims(ForthonObject *obj)
{
}
static void tree_nodesetdims(char *name,ForthonObject *obj,long i)
{
}
PyObject *fKD_tree_nodeNew(PyObject *self, PyObject *args)
{
  return tree_nodenewf_();
}
static struct PyMethodDef tree_node_methods[]={{NULL,NULL}};
void inittree_nodepy_(long *i,char *fobj,ForthonObject **cobj__,long *setinitvalues,long *deallocatable)
{
  ForthonObject *obj;
  obj=(ForthonObject *) PyObject_GC_New(ForthonObject,&ForthonType);
  if (*i > 0) {obj->name = fKD_fscalars[*i].name;}
  else        {obj->name = tree_nodepointee__;}
  obj->typename = "tree_node";
  tree_nodedeclarevars(obj);
  obj->setdims = *tree_nodesetdims;
  obj->setstaticdims = *tree_nodesetstaticdims;
  obj->fmethods = tree_node_methods;
  obj->__module__ = Py_BuildValue("s","fKDpy");
  obj->fobj = fobj;
  if (*deallocatable==1)
    obj->fobjdeallocate=*tree_nodedeallocatef_;
  else
    obj->fobjdeallocate = NULL;
  obj->nullifycobj=*tree_nodenullifycobjf_;
  obj->allocated = 0;
  obj->garbagecollected = 1;
  *cobj__ = obj;
  if (PyErr_Occurred()) {
    PyErr_Print();
    Py_FatalError("can not initialize type tree_node");
    }
  Forthon_BuildDicts(obj);
  ForthonPackage_allotdims(obj);
  tree_nodepasspointers_(fobj,setinitvalues);
  tree_nodenullifypointers_(fobj);
  ForthonPackage_staticarrays(obj);
  PyObject_GC_Track((PyObject *)obj);
}
void increftree_nodepy_(ForthonObject **cobj__,char *fobj)
{
  if (*cobj__ == NULL) {
    long i=-1,s=0,d=0;
    inittree_nodepy_(&i,fobj,cobj__,&s,&d);}
  else {
    Py_INCREF(*cobj__);}
}
void decreftree_nodepy_(ForthonObject **cobj__)
{
  Py_XDECREF(*cobj__);
}
void tree_nodemakedeallocable_(ForthonObject **cobj)
{
  (*cobj)->fobjdeallocate=*tree_nodedeallocatef_;
}
void tree_nodesetscalarpointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the scalars */
  (*obj)->fscalars[*i].data = (char *)p;
}
void tree_nodesetderivedtypepointers_(long *i,char **p,ForthonObject **obj)
{
  /* Get pointers for the derived types */
  (*obj)->fscalars[*i].data = (char *)(*p);
}
void tree_nodesetarraypointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the arrays */
  (*obj)->farrays[*i].data.s = (char *)p;
}
void tree_nodesetarraypointersobj_(Fortranarray *farray,char *p)
{
  /* Get pointers for the arrays */
  farray->data.s = (char *)p;
}
void tree_nodesetarraydims_(Fortranarray *farray,long *dims)
{
  int id;
  for (id=0;id<farray->nd;id++)
    farray->dimensions[farray->nd-1-id] = (npy_intp)(dims[id]);
}

static char* kdtree2pointee__ = "kdtree2";
extern void kdtree2passpointers_(char *fobj,long *setinitvalues);
extern void kdtree2nullifypointers_(char *fobj);
extern PyObject *kdtree2newf_(void);
extern void kdtree2deallocatef_(void);
extern void kdtree2nullifycobjf_(void);
extern void kdtree2setpointerdimen_(char *p,char *fobj,int *nullit);
extern void kdtree2setpointern_(char *p,char *fobj,int *nullit);
extern void kdtree2setpointersort_(char *p,char *fobj,int *nullit);
extern void kdtree2setpointerrearrange_(char *p,char *fobj,int *nullit);
extern void kdtree2setpointerroot_(char *p,char *fobj,int *nullit);
extern void kdtree2getpointerroot_(ForthonObject **cobj__,char *obj,int *createnew__);
extern void kdtree2setpointerthe_data_(char *p,char *fobj,npy_intp *dims__);
extern void kdtree2getpointerthe_data_(long *i,char* fobj);
extern void kdtree2setpointerind_(char *p,char *fobj,npy_intp *dims__);
extern void kdtree2getpointerind_(long *i,char* fobj);
extern void kdtree2setpointwlxczqgkqomsxthc_(char *p,char *fobj,npy_intp *dims__);
extern void kdtree2getpointcurmvnplywqptecx_(long *i,char* fobj);


void kdtree2declarevars(ForthonObject *obj) {
obj->nscalars = 5;
obj->fscalars = PyMem_Malloc(obj->nscalars*sizeof(Fortranscalar));
obj->fscalars[0].type = PyArray_LONG;
obj->fscalars[0].typename = "integer";
obj->fscalars[0].name = "dimen";
obj->fscalars[0].data = NULL;
obj->fscalars[0].group = "kdtree2";
obj->fscalars[0].attributes = " kdtree2 ";
obj->fscalars[0].comment = "";
obj->fscalars[0].dynamic = 0;
obj->fscalars[0].setpointer = *kdtree2setpointerdimen_;
obj->fscalars[0].getpointer = NULL;
obj->fscalars[0].setaction = NULL;
obj->fscalars[0].getaction = NULL;
obj->fscalars[1].type = PyArray_LONG;
obj->fscalars[1].typename = "integer";
obj->fscalars[1].name = "n";
obj->fscalars[1].data = NULL;
obj->fscalars[1].group = "kdtree2";
obj->fscalars[1].attributes = " kdtree2 ";
obj->fscalars[1].comment = "dimensionality and total # of points";
obj->fscalars[1].dynamic = 0;
obj->fscalars[1].setpointer = *kdtree2setpointern_;
obj->fscalars[1].getpointer = NULL;
obj->fscalars[1].setaction = NULL;
obj->fscalars[1].getaction = NULL;
obj->fscalars[2].type = PyArray_LONG;
obj->fscalars[2].typename = "logical";
obj->fscalars[2].name = "sort";
obj->fscalars[2].data = NULL;
obj->fscalars[2].group = "kdtree2";
obj->fscalars[2].attributes = " kdtree2 ";
obj->fscalars[2].comment = "logical :: sort = .false.";
obj->fscalars[2].dynamic = 0;
obj->fscalars[2].setpointer = *kdtree2setpointersort_;
obj->fscalars[2].getpointer = NULL;
obj->fscalars[2].setaction = NULL;
obj->fscalars[2].getaction = NULL;
obj->fscalars[3].type = PyArray_LONG;
obj->fscalars[3].typename = "logical";
obj->fscalars[3].name = "rearrange";
obj->fscalars[3].data = NULL;
obj->fscalars[3].group = "kdtree2";
obj->fscalars[3].attributes = " kdtree2 ";
obj->fscalars[3].comment = "logical :: rearrange = .false.";
obj->fscalars[3].dynamic = 0;
obj->fscalars[3].setpointer = *kdtree2setpointerrearrange_;
obj->fscalars[3].getpointer = NULL;
obj->fscalars[3].setaction = NULL;
obj->fscalars[3].getaction = NULL;
obj->fscalars[4].type = PyArray_OBJECT;
obj->fscalars[4].typename = "tree_node";
obj->fscalars[4].name = "root";
obj->fscalars[4].data = NULL;
obj->fscalars[4].group = "kdtree2";
obj->fscalars[4].attributes = " kdtree2 ";
obj->fscalars[4].comment = "type(tree_node), pointer :: root => null()\nroot pointer of the tree";
obj->fscalars[4].dynamic = 1;
obj->fscalars[4].setpointer = *kdtree2setpointerroot_;
obj->fscalars[4].getpointer = *kdtree2getpointerroot_;
obj->fscalars[4].setaction = NULL;
obj->fscalars[4].getaction = NULL;
obj->narrays = 3;
obj->farrays = PyMem_Malloc(obj->narrays*sizeof(Fortranarray));
obj->farrays[0].type = PyArray_DOUBLE;
obj->farrays[0].dynamic = 3;
obj->farrays[0].nd = 2;
obj->farrays[0].dimensions = (npy_intp*)NULL;
obj->farrays[0].name = "the_data";
obj->farrays[0].data.s = (char *)NULL;
obj->farrays[0].setpointer = *kdtree2setpointerthe_data_;
obj->farrays[0].getpointer = *kdtree2getpointerthe_data_;
obj->farrays[0].setaction = NULL;
obj->farrays[0].getaction = NULL;
obj->farrays[0].initvalue = 0;
obj->farrays[0].pya = NULL;
obj->farrays[0].group = "kdtree2";
obj->farrays[0].attributes = " kdtree2  fassign  fassign ";
obj->farrays[0].comment = "real(kdkind), pointer :: the_data(:,:) => null()\npointer to the actual data array \nIMPORTANT NOTE: IT IS DIMENSIONED the_data(1:d,1:N)\nwhich may be opposite of what may be conventional.\nThis is, because in Fortran, the memory layout is such that\nthe first dimension is in sequential order. Hence, with\n(1:d,1:N), all components of the vector will be in consecutive\nmemory locations. The search time is dominated by the\nevaluation of distances in the terminal nodes. Putting all\nvector components in consecutive memory location improves\nmemory cache locality, and hence search speed, and may enable \nvectorization on some processors and compilers.";
obj->farrays[0].dimstring = "(:,:)";
obj->farrays[1].type = PyArray_LONG;
obj->farrays[1].dynamic = 3;
obj->farrays[1].nd = 1;
obj->farrays[1].dimensions = (npy_intp*)NULL;
obj->farrays[1].name = "ind";
obj->farrays[1].data.s = (char *)NULL;
obj->farrays[1].setpointer = *kdtree2setpointerind_;
obj->farrays[1].getpointer = *kdtree2getpointerind_;
obj->farrays[1].setaction = NULL;
obj->farrays[1].getaction = NULL;
obj->farrays[1].initvalue = 0;
obj->farrays[1].pya = NULL;
obj->farrays[1].group = "kdtree2";
obj->farrays[1].attributes = " kdtree2  fassign ";
obj->farrays[1].comment = "integer, pointer :: ind(:) => null()\npermuted index into the data, so that indexes[l..u] of some\nbucket represent the indexes of the actual points in that\nbucket.\ndo we always sort output results?";
obj->farrays[1].dimstring = "(:)";
obj->farrays[2].type = PyArray_DOUBLE;
obj->farrays[2].dynamic = 3;
obj->farrays[2].nd = 2;
obj->farrays[2].dimensions = (npy_intp*)NULL;
obj->farrays[2].name = "rearranged_data";
obj->farrays[2].data.s = (char *)NULL;
obj->farrays[2].setpointer = *kdtree2setpointwlxczqgkqomsxthc_;
obj->farrays[2].getpointer = *kdtree2getpointcurmvnplywqptecx_;
obj->farrays[2].setaction = NULL;
obj->farrays[2].getaction = NULL;
obj->farrays[2].initvalue = 0;
obj->farrays[2].pya = NULL;
obj->farrays[2].group = "kdtree2";
obj->farrays[2].attributes = " kdtree2  fassign  fassign ";
obj->farrays[2].comment = "real(kdkind), pointer :: rearranged_data(:,:) => null()\nif (rearrange .eqv. .true.) then rearranged_data has been\ncreated so that rearranged_data(:,i) = the_data(:,ind(i)),\npermitting search to use more cache-friendly rearranged_data, at\nsome initial computation and storage cost.";
obj->farrays[2].dimstring = "(:,:)";
}
void kdtree2setstaticdims(ForthonObject *obj)
{
}
static void kdtree2setdims(char *name,ForthonObject *obj,long i)
{
}
PyObject *fKD_kdtree2New(PyObject *self, PyObject *args)
{
  return kdtree2newf_();
}
static struct PyMethodDef kdtree2_methods[]={{NULL,NULL}};
void initkdtree2py_(long *i,char *fobj,ForthonObject **cobj__,long *setinitvalues,long *deallocatable)
{
  ForthonObject *obj;
  obj=(ForthonObject *) PyObject_GC_New(ForthonObject,&ForthonType);
  if (*i > 0) {obj->name = fKD_fscalars[*i].name;}
  else        {obj->name = kdtree2pointee__;}
  obj->typename = "kdtree2";
  kdtree2declarevars(obj);
  obj->setdims = *kdtree2setdims;
  obj->setstaticdims = *kdtree2setstaticdims;
  obj->fmethods = kdtree2_methods;
  obj->__module__ = Py_BuildValue("s","fKDpy");
  obj->fobj = fobj;
  if (*deallocatable==1)
    obj->fobjdeallocate=*kdtree2deallocatef_;
  else
    obj->fobjdeallocate = NULL;
  obj->nullifycobj=*kdtree2nullifycobjf_;
  obj->allocated = 0;
  obj->garbagecollected = 0;
  *cobj__ = obj;
  if (PyErr_Occurred()) {
    PyErr_Print();
    Py_FatalError("can not initialize type kdtree2");
    }
  Forthon_BuildDicts(obj);
  ForthonPackage_allotdims(obj);
  kdtree2passpointers_(fobj,setinitvalues);
  kdtree2nullifypointers_(fobj);
  ForthonPackage_staticarrays(obj);
}
void increfkdtree2py_(ForthonObject **cobj__,char *fobj)
{
  if (*cobj__ == NULL) {
    long i=-1,s=0,d=0;
    initkdtree2py_(&i,fobj,cobj__,&s,&d);}
  else {
    Py_INCREF(*cobj__);}
}
void decrefkdtree2py_(ForthonObject **cobj__)
{
  Py_XDECREF(*cobj__);
}
void kdtree2makedeallocable_(ForthonObject **cobj)
{
  (*cobj)->fobjdeallocate=*kdtree2deallocatef_;
}
void kdtree2setscalarpointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the scalars */
  (*obj)->fscalars[*i].data = (char *)p;
}
void kdtree2setderivedtypepointers_(long *i,char **p,ForthonObject **obj)
{
  /* Get pointers for the derived types */
  (*obj)->fscalars[*i].data = (char *)(*p);
}
void kdtree2setarraypointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the arrays */
  (*obj)->farrays[*i].data.s = (char *)p;
}
void kdtree2setarraypointersobj_(Fortranarray *farray,char *p)
{
  /* Get pointers for the arrays */
  farray->data.s = (char *)p;
}
void kdtree2setarraydims_(Fortranarray *farray,long *dims)
{
  int id;
  for (id=0;id<farray->nd;id++)
    farray->dimensions[farray->nd-1-id] = (npy_intp)(dims[id]);
}

static char* tree_setpointee__ = "tree_set";
extern void tree_setpasspointers_(char *fobj,long *setinitvalues);
extern void tree_setnullifypointers_(char *fobj);
extern PyObject *tree_setnewf_(void);
extern void tree_setdeallocatef_(void);
extern void tree_setnullifycobjf_(void);
extern void tree_setsetpointernparts_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointernn_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointernmerge_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointerstart_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointerfinish_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointertree2_(char *p,char *fobj,int *nullit);
extern void tree_setgetpointertree2_(ForthonObject **cobj__,char *obj,int *createnew__);
extern void tree_setsetpointersort_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointerrearrange_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointerradius_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointerradius_n_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointernfound_(char *p,char *fobj,int *nullit);
extern void tree_setsetpointertags_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointertags_(long *i,char* fobj);
extern void tree_setsetpointerdist_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointerdist_(long *i,char* fobj);
extern void tree_setsetpointernn_tags_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointernn_tags_(long *i,char* fobj);
extern void tree_setsetpointerchunk_tags_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointerchunk_tags_(long *i,char* fobj);
extern void tree_setsetpointernn_dist_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointernn_dist_(long *i,char* fobj);
extern void tree_setsetpointerpos_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointerpos_(long *i,char* fobj);
extern void tree_setsetpointerdens_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointerdens_(long *i,char* fobj);
extern void tree_setsetpointermass_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointermass_(long *i,char* fobj);
extern void tree_setsetpointerqv_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setsetpointerqv_many_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointerqv_many_(long *i,char* fobj);
extern void tree_setsetpointernfound_many_(char *p,char *fobj,npy_intp *dims__);
extern void tree_setgetpointernfound_many_(long *i,char* fobj);


void tree_setdeclarevars(ForthonObject *obj) {
obj->nscalars = 11;
obj->fscalars = PyMem_Malloc(obj->nscalars*sizeof(Fortranscalar));
obj->fscalars[0].type = PyArray_LONG;
obj->fscalars[0].typename = "integer";
obj->fscalars[0].name = "nparts";
obj->fscalars[0].data = NULL;
obj->fscalars[0].group = "tree_set";
obj->fscalars[0].attributes = " tree_set ";
obj->fscalars[0].comment = "";
obj->fscalars[0].dynamic = 0;
obj->fscalars[0].setpointer = *tree_setsetpointernparts_;
obj->fscalars[0].getpointer = NULL;
obj->fscalars[0].setaction = NULL;
obj->fscalars[0].getaction = NULL;
obj->fscalars[1].type = PyArray_LONG;
obj->fscalars[1].typename = "integer";
obj->fscalars[1].name = "nn";
obj->fscalars[1].data = NULL;
obj->fscalars[1].group = "tree_set";
obj->fscalars[1].attributes = " tree_set ";
obj->fscalars[1].comment = "";
obj->fscalars[1].dynamic = 0;
obj->fscalars[1].setpointer = *tree_setsetpointernn_;
obj->fscalars[1].getpointer = NULL;
obj->fscalars[1].setaction = NULL;
obj->fscalars[1].getaction = NULL;
obj->fscalars[2].type = PyArray_LONG;
obj->fscalars[2].typename = "integer";
obj->fscalars[2].name = "nMerge";
obj->fscalars[2].data = NULL;
obj->fscalars[2].group = "tree_set";
obj->fscalars[2].attributes = " tree_set ";
obj->fscalars[2].comment = "number of nearest neighbors used in chain merging";
obj->fscalars[2].dynamic = 0;
obj->fscalars[2].setpointer = *tree_setsetpointernmerge_;
obj->fscalars[2].getpointer = NULL;
obj->fscalars[2].setaction = NULL;
obj->fscalars[2].getaction = NULL;
obj->fscalars[3].type = PyArray_LONG;
obj->fscalars[3].typename = "integer";
obj->fscalars[3].name = "start";
obj->fscalars[3].data = NULL;
obj->fscalars[3].group = "tree_set";
obj->fscalars[3].attributes = " tree_set ";
obj->fscalars[3].comment = "";
obj->fscalars[3].dynamic = 0;
obj->fscalars[3].setpointer = *tree_setsetpointerstart_;
obj->fscalars[3].getpointer = NULL;
obj->fscalars[3].setaction = NULL;
obj->fscalars[3].getaction = NULL;
obj->fscalars[4].type = PyArray_LONG;
obj->fscalars[4].typename = "integer";
obj->fscalars[4].name = "finish";
obj->fscalars[4].data = NULL;
obj->fscalars[4].group = "tree_set";
obj->fscalars[4].attributes = " tree_set ";
obj->fscalars[4].comment = "";
obj->fscalars[4].dynamic = 0;
obj->fscalars[4].setpointer = *tree_setsetpointerfinish_;
obj->fscalars[4].getpointer = NULL;
obj->fscalars[4].setaction = NULL;
obj->fscalars[4].getaction = NULL;
obj->fscalars[5].type = PyArray_OBJECT;
obj->fscalars[5].typename = "kdtree2";
obj->fscalars[5].name = "tree2";
obj->fscalars[5].data = NULL;
obj->fscalars[5].group = "tree_set";
obj->fscalars[5].attributes = " tree_set ";
obj->fscalars[5].comment = "";
obj->fscalars[5].dynamic = 1;
obj->fscalars[5].setpointer = *tree_setsetpointertree2_;
obj->fscalars[5].getpointer = *tree_setgetpointertree2_;
obj->fscalars[5].setaction = NULL;
obj->fscalars[5].getaction = NULL;
obj->fscalars[6].type = PyArray_LONG;
obj->fscalars[6].typename = "logical";
obj->fscalars[6].name = "sort";
obj->fscalars[6].data = NULL;
obj->fscalars[6].group = "tree_set";
obj->fscalars[6].attributes = " tree_set ";
obj->fscalars[6].comment = "";
obj->fscalars[6].dynamic = 0;
obj->fscalars[6].setpointer = *tree_setsetpointersort_;
obj->fscalars[6].getpointer = NULL;
obj->fscalars[6].setaction = NULL;
obj->fscalars[6].getaction = NULL;
obj->fscalars[7].type = PyArray_LONG;
obj->fscalars[7].typename = "logical";
obj->fscalars[7].name = "rearrange";
obj->fscalars[7].data = NULL;
obj->fscalars[7].group = "tree_set";
obj->fscalars[7].attributes = " tree_set ";
obj->fscalars[7].comment = "";
obj->fscalars[7].dynamic = 0;
obj->fscalars[7].setpointer = *tree_setsetpointerrearrange_;
obj->fscalars[7].getpointer = NULL;
obj->fscalars[7].setaction = NULL;
obj->fscalars[7].getaction = NULL;
obj->fscalars[8].type = PyArray_DOUBLE;
obj->fscalars[8].typename = "real";
obj->fscalars[8].name = "radius";
obj->fscalars[8].data = NULL;
obj->fscalars[8].group = "tree_set";
obj->fscalars[8].attributes = " tree_set ";
obj->fscalars[8].comment = "the unsquared radius for radius searches";
obj->fscalars[8].dynamic = 0;
obj->fscalars[8].setpointer = *tree_setsetpointerradius_;
obj->fscalars[8].getpointer = NULL;
obj->fscalars[8].setaction = NULL;
obj->fscalars[8].getaction = NULL;
obj->fscalars[9].type = PyArray_LONG;
obj->fscalars[9].typename = "integer";
obj->fscalars[9].name = "radius_n";
obj->fscalars[9].data = NULL;
obj->fscalars[9].group = "tree_set";
obj->fscalars[9].attributes = " tree_set ";
obj->fscalars[9].comment = "the number of results to return";
obj->fscalars[9].dynamic = 0;
obj->fscalars[9].setpointer = *tree_setsetpointerradius_n_;
obj->fscalars[9].getpointer = NULL;
obj->fscalars[9].setaction = NULL;
obj->fscalars[9].getaction = NULL;
obj->fscalars[10].type = PyArray_LONG;
obj->fscalars[10].typename = "integer";
obj->fscalars[10].name = "nfound";
obj->fscalars[10].data = NULL;
obj->fscalars[10].group = "tree_set";
obj->fscalars[10].attributes = " tree_set ";
obj->fscalars[10].comment = "number of neighbors within radius";
obj->fscalars[10].dynamic = 0;
obj->fscalars[10].setpointer = *tree_setsetpointernfound_;
obj->fscalars[10].getpointer = NULL;
obj->fscalars[10].setaction = NULL;
obj->fscalars[10].getaction = NULL;
obj->narrays = 11;
obj->farrays = PyMem_Malloc(obj->narrays*sizeof(Fortranarray));
obj->farrays[0].type = PyArray_LONG;
obj->farrays[0].dynamic = 3;
obj->farrays[0].nd = 1;
obj->farrays[0].dimensions = (npy_intp*)NULL;
obj->farrays[0].name = "tags";
obj->farrays[0].data.s = (char *)NULL;
obj->farrays[0].setpointer = *tree_setsetpointertags_;
obj->farrays[0].getpointer = *tree_setgetpointertags_;
obj->farrays[0].setaction = NULL;
obj->farrays[0].getaction = NULL;
obj->farrays[0].initvalue = 0;
obj->farrays[0].pya = NULL;
obj->farrays[0].group = "tree_set";
obj->farrays[0].attributes = " tree_set  fassign ";
obj->farrays[0].comment = "particle ID tags";
obj->farrays[0].dimstring = "(:)";
obj->farrays[1].type = PyArray_DOUBLE;
obj->farrays[1].dynamic = 3;
obj->farrays[1].nd = 1;
obj->farrays[1].dimensions = (npy_intp*)NULL;
obj->farrays[1].name = "dist";
obj->farrays[1].data.s = (char *)NULL;
obj->farrays[1].setpointer = *tree_setsetpointerdist_;
obj->farrays[1].getpointer = *tree_setgetpointerdist_;
obj->farrays[1].setaction = NULL;
obj->farrays[1].getaction = NULL;
obj->farrays[1].initvalue = 0;
obj->farrays[1].pya = NULL;
obj->farrays[1].group = "tree_set";
obj->farrays[1].attributes = " tree_set  fassign ";
obj->farrays[1].comment = "interparticle spacings";
obj->farrays[1].dimstring = "(:)";
obj->farrays[2].type = PyArray_LONG;
obj->farrays[2].dynamic = 3;
obj->farrays[2].nd = 2;
obj->farrays[2].dimensions = (npy_intp*)NULL;
obj->farrays[2].name = "nn_tags";
obj->farrays[2].data.s = (char *)NULL;
obj->farrays[2].setpointer = *tree_setsetpointernn_tags_;
obj->farrays[2].getpointer = *tree_setgetpointernn_tags_;
obj->farrays[2].setaction = NULL;
obj->farrays[2].getaction = NULL;
obj->farrays[2].initvalue = 0;
obj->farrays[2].pya = NULL;
obj->farrays[2].group = "tree_set";
obj->farrays[2].attributes = " tree_set  fassign  fassign ";
obj->farrays[2].comment = "for all particles at once, [nth neighbor, index]";
obj->farrays[2].dimstring = "(:,:)";
obj->farrays[3].type = PyArray_LONG;
obj->farrays[3].dynamic = 3;
obj->farrays[3].nd = 2;
obj->farrays[3].dimensions = (npy_intp*)NULL;
obj->farrays[3].name = "chunk_tags";
obj->farrays[3].data.s = (char *)NULL;
obj->farrays[3].setpointer = *tree_setsetpointerchunk_tags_;
obj->farrays[3].getpointer = *tree_setgetpointerchunk_tags_;
obj->farrays[3].setaction = NULL;
obj->farrays[3].getaction = NULL;
obj->farrays[3].initvalue = 0;
obj->farrays[3].pya = NULL;
obj->farrays[3].group = "tree_set";
obj->farrays[3].attributes = " tree_set  fassign  fassign ";
obj->farrays[3].comment = "for finding only a chunk of the nearest neighbors";
obj->farrays[3].dimstring = "(:,:)";
obj->farrays[4].type = PyArray_DOUBLE;
obj->farrays[4].dynamic = 3;
obj->farrays[4].nd = 2;
obj->farrays[4].dimensions = (npy_intp*)NULL;
obj->farrays[4].name = "nn_dist";
obj->farrays[4].data.s = (char *)NULL;
obj->farrays[4].setpointer = *tree_setsetpointernn_dist_;
obj->farrays[4].getpointer = *tree_setgetpointernn_dist_;
obj->farrays[4].setaction = NULL;
obj->farrays[4].getaction = NULL;
obj->farrays[4].initvalue = 0;
obj->farrays[4].pya = NULL;
obj->farrays[4].group = "tree_set";
obj->farrays[4].attributes = " tree_set  fassign  fassign ";
obj->farrays[4].comment = "";
obj->farrays[4].dimstring = "(:,:)";
obj->farrays[5].type = PyArray_DOUBLE;
obj->farrays[5].dynamic = 3;
obj->farrays[5].nd = 2;
obj->farrays[5].dimensions = (npy_intp*)NULL;
obj->farrays[5].name = "pos";
obj->farrays[5].data.s = (char *)NULL;
obj->farrays[5].setpointer = *tree_setsetpointerpos_;
obj->farrays[5].getpointer = *tree_setgetpointerpos_;
obj->farrays[5].setaction = NULL;
obj->farrays[5].getaction = NULL;
obj->farrays[5].initvalue = 0;
obj->farrays[5].pya = NULL;
obj->farrays[5].group = "tree_set";
obj->farrays[5].attributes = " tree_set  fassign ";
obj->farrays[5].comment = "";
obj->farrays[5].dimstring = "(3,:)";
obj->farrays[6].type = PyArray_DOUBLE;
obj->farrays[6].dynamic = 3;
obj->farrays[6].nd = 1;
obj->farrays[6].dimensions = (npy_intp*)NULL;
obj->farrays[6].name = "dens";
obj->farrays[6].data.s = (char *)NULL;
obj->farrays[6].setpointer = *tree_setsetpointerdens_;
obj->farrays[6].getpointer = *tree_setgetpointerdens_;
obj->farrays[6].setaction = NULL;
obj->farrays[6].getaction = NULL;
obj->farrays[6].initvalue = 0;
obj->farrays[6].pya = NULL;
obj->farrays[6].group = "tree_set";
obj->farrays[6].attributes = " tree_set  fassign ";
obj->farrays[6].comment = "";
obj->farrays[6].dimstring = "(:)";
obj->farrays[7].type = PyArray_DOUBLE;
obj->farrays[7].dynamic = 3;
obj->farrays[7].nd = 1;
obj->farrays[7].dimensions = (npy_intp*)NULL;
obj->farrays[7].name = "mass";
obj->farrays[7].data.s = (char *)NULL;
obj->farrays[7].setpointer = *tree_setsetpointermass_;
obj->farrays[7].getpointer = *tree_setgetpointermass_;
obj->farrays[7].setaction = NULL;
obj->farrays[7].getaction = NULL;
obj->farrays[7].initvalue = 0;
obj->farrays[7].pya = NULL;
obj->farrays[7].group = "tree_set";
obj->farrays[7].attributes = " tree_set  fassign ";
obj->farrays[7].comment = "";
obj->farrays[7].dimstring = "(:)";
obj->farrays[8].type = PyArray_DOUBLE;
obj->farrays[8].dynamic = 0;
obj->farrays[8].nd = 1;
obj->farrays[8].dimensions = (npy_intp*)NULL;
obj->farrays[8].name = "qv";
obj->farrays[8].data.s = (char *)NULL;
obj->farrays[8].setpointer = NULL;
obj->farrays[8].getpointer = NULL;
obj->farrays[8].setaction = NULL;
obj->farrays[8].getaction = NULL;
obj->farrays[8].initvalue = 0;
obj->farrays[8].pya = NULL;
obj->farrays[8].group = "tree_set";
obj->farrays[8].attributes = " tree_set ";
obj->farrays[8].comment = "";
obj->farrays[8].dimstring = "(3)";
obj->farrays[9].type = PyArray_DOUBLE;
obj->farrays[9].dynamic = 3;
obj->farrays[9].nd = 2;
obj->farrays[9].dimensions = (npy_intp*)NULL;
obj->farrays[9].name = "qv_many";
obj->farrays[9].data.s = (char *)NULL;
obj->farrays[9].setpointer = *tree_setsetpointerqv_many_;
obj->farrays[9].getpointer = *tree_setgetpointerqv_many_;
obj->farrays[9].setaction = NULL;
obj->farrays[9].getaction = NULL;
obj->farrays[9].initvalue = 0;
obj->farrays[9].pya = NULL;
obj->farrays[9].group = "tree_set";
obj->farrays[9].attributes = " tree_set  fassign ";
obj->farrays[9].comment = "";
obj->farrays[9].dimstring = "(3,:)";
obj->farrays[10].type = PyArray_LONG;
obj->farrays[10].dynamic = 3;
obj->farrays[10].nd = 1;
obj->farrays[10].dimensions = (npy_intp*)NULL;
obj->farrays[10].name = "nfound_many";
obj->farrays[10].data.s = (char *)NULL;
obj->farrays[10].setpointer = *tree_setsetpointernfound_many_;
obj->farrays[10].getpointer = *tree_setgetpointernfound_many_;
obj->farrays[10].setaction = NULL;
obj->farrays[10].getaction = NULL;
obj->farrays[10].initvalue = 0;
obj->farrays[10].pya = NULL;
obj->farrays[10].group = "tree_set";
obj->farrays[10].attributes = " tree_set  fassign ";
obj->farrays[10].comment = "an array of number of neighbors within radius";
obj->farrays[10].dimstring = "(:)";
}
void tree_setsetstaticdims(ForthonObject *obj)
{
  obj->farrays[8].dimensions[0] = (npy_intp)((3) - (1) + 1);
}
static void tree_setsetdims(char *name,ForthonObject *obj,long i)
{
}
PyObject *fKD_tree_setNew(PyObject *self, PyObject *args)
{
  return tree_setnewf_();
}
static struct PyMethodDef tree_set_methods[]={{NULL,NULL}};
void inittree_setpy_(long *i,char *fobj,ForthonObject **cobj__,long *setinitvalues,long *deallocatable)
{
  ForthonObject *obj;
  obj=(ForthonObject *) PyObject_GC_New(ForthonObject,&ForthonType);
  if (*i > 0) {obj->name = fKD_fscalars[*i].name;}
  else        {obj->name = tree_setpointee__;}
  obj->typename = "tree_set";
  tree_setdeclarevars(obj);
  obj->setdims = *tree_setsetdims;
  obj->setstaticdims = *tree_setsetstaticdims;
  obj->fmethods = tree_set_methods;
  obj->__module__ = Py_BuildValue("s","fKDpy");
  obj->fobj = fobj;
  if (*deallocatable==1)
    obj->fobjdeallocate=*tree_setdeallocatef_;
  else
    obj->fobjdeallocate = NULL;
  obj->nullifycobj=*tree_setnullifycobjf_;
  obj->allocated = 0;
  obj->garbagecollected = 0;
  *cobj__ = obj;
  if (PyErr_Occurred()) {
    PyErr_Print();
    Py_FatalError("can not initialize type tree_set");
    }
  Forthon_BuildDicts(obj);
  ForthonPackage_allotdims(obj);
  tree_setpasspointers_(fobj,setinitvalues);
  tree_setnullifypointers_(fobj);
  ForthonPackage_staticarrays(obj);
}
void increftree_setpy_(ForthonObject **cobj__,char *fobj)
{
  if (*cobj__ == NULL) {
    long i=-1,s=0,d=0;
    inittree_setpy_(&i,fobj,cobj__,&s,&d);}
  else {
    Py_INCREF(*cobj__);}
}
void decreftree_setpy_(ForthonObject **cobj__)
{
  Py_XDECREF(*cobj__);
}
void tree_setmakedeallocable_(ForthonObject **cobj)
{
  (*cobj)->fobjdeallocate=*tree_setdeallocatef_;
}
void tree_setsetscalarpointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the scalars */
  (*obj)->fscalars[*i].data = (char *)p;
}
void tree_setsetderivedtypepointers_(long *i,char **p,ForthonObject **obj)
{
  /* Get pointers for the derived types */
  (*obj)->fscalars[*i].data = (char *)(*p);
}
void tree_setsetarraypointers_(long *i,char *p,ForthonObject **obj)
{
  /* Get pointers for the arrays */
  (*obj)->farrays[*i].data.s = (char *)p;
}
void tree_setsetarraypointersobj_(Fortranarray *farray,char *p)
{
  /* Get pointers for the arrays */
  farray->data.s = (char *)p;
}
void tree_setsetarraydims_(Fortranarray *farray,long *dims)
{
  int id;
  for (id=0;id<farray->nd;id++)
    farray->dimensions[farray->nd-1-id] = (npy_intp)(dims[id]);
}
